Imports System.Xml
''' <summary>
'''  Abschnitt einer MP3-Datei mit eigenem Titel und Interpreten
''' </summary>
Public Class MP3FileSection

#Region " Fields / Events "

    ''' <summary>
    ''' Titel und Interpret
    ''' </summary>
    Private m_Text As String

    ''' <summary>
    ''' Endposition des Abschnitts innerhalb der Datei
    ''' </summary>
    Private m_EndPosition As Long

    ''' <summary>
    ''' Erstellungszeitpunkt des Abschnitts
    ''' </summary>
    Private m_CreationTime As Date

#End Region

#Region " Constructor "

    ''' <summary>
    ''' Konstruktor zum Erstellen eines neuen MP3-Dateiabschnitts
    ''' </summary>
    ''' <param name="Text">Titel und Interpret</param>
    ''' <param name="EndPosition">Endposition des Abschnitts innerhalb der MP3-Datei</param>
    ''' <param name="CreationTime">Erstellungszeitpunkt des Abschnitts</param>
    Public Sub New(ByVal Text As String, ByVal EndPosition As Long, ByVal CreationTime As Date)
        m_Text = Text
        m_EndPosition = EndPosition
        m_CreationTime = CreationTime
    End Sub

    ''' <summary>
    ''' Konstruktor zum Erstellen aus Informationen einer XML-Datei
    ''' </summary>
    ''' <param name="Nd">XmlNode</param>
    Public Sub New(ByVal Nd As XmlNode)
        m_Text = Nd.Attributes("Text").Value
        m_EndPosition = CLng(Nd.Attributes("EndPosition").Value)
        m_CreationTime = New Date(CLng(Nd.Attributes("EndTime").Value))
    End Sub

#End Region

#Region " Properties "

    ''' <summary>
    ''' Titel und Interpret
    ''' </summary>
    ReadOnly Property Text() As String
        Get
            Return m_Text
        End Get
    End Property

    ''' <summary>
    ''' Endposition des Abschnitts innerhalb der Datei
    ''' </summary>
    Property EndPosition() As Long
        Get
            Return m_EndPosition
        End Get
        Set(ByVal value As Long)
            m_EndPosition = value
        End Set
    End Property
    ''' <summary>
    ''' Erstellungszeitpunkt des Abschnitts
    ''' </summary>
    ReadOnly Property CreationTime() As Date
        Get
            Return m_CreationTime
        End Get
    End Property

#End Region

#Region " Methods "

    ''' <summary>
    ''' schreibt den Inhalt des Abschnitts in eine XML-Datei
    ''' </summary>
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Text", m_Text)
        Writer.WriteAttributeString("EndPosition", m_EndPosition.ToString)
        Writer.WriteAttributeString("EndTime", m_CreationTime.Ticks.ToString)
    End Sub

#End Region

End Class
