Imports System.Xml
''' <summary>
''' enthlt einen Auftrag zum Aufzeichnen einer Radiostation in einem angegebenen Zeitraum
''' </summary>
Public MustInherit Class RecordingTask

#Region " Fields / Events "

    ''' <summary>
    ''' Event bei nderung
    ''' </summary>
    Public Event Changed()

#End Region

#Region " Constructor "

    Public Sub New()

    End Sub

    ''' <summary>
    ''' Konstruktor beim Lesen einer XML-Datei
    ''' </summary>
    Public Sub New(ByVal Nd As XmlNode)

    End Sub

#End Region

#Region " Properties "

    ''' <summary>
    ''' zum Identifizieren ohne Reflection
    ''' </summary>
    MustOverride ReadOnly Property Type() As RecordingTaskTypes

#End Region

#Region " Methods "

    ''' <summary>
    ''' lst das nderungs-Event aus
    ''' </summary>
    Public Sub RaiseChanged()
        RaiseEvent Changed()
    End Sub

    ''' <summary>
    ''' schreibt den Inhalt in eine XML-Datei
    ''' </summary>
    Public MustOverride Sub Write_XML(ByVal Writer As XmlTextWriter)

    ''' <summary>
    ''' gibt zurck, ob diese Aufgabe zum angegebenen Zeitpunkt aktiv ist
    ''' </summary>
    MustOverride Function IsActive(ByVal Time As Date) As Boolean

    ''' <summary>
    ''' erstellt eine neue RecordingTask-Instanz mit gleichem Inhalt
    ''' </summary>
    MustOverride Function CreateClone() As RecordingTask

    ''' <summary>
    ''' liefert ein Control zum Bearbeiten der aktuellen RecordingTask-Instanz
    ''' </summary>
    MustOverride Function EditControl() As Control

#End Region

End Class
