''' <summary>
''' speichert eine MP3-Datei mit Forschritts-Formular
''' </summary>
Public Class MP3FileSaverSingle
    Inherits MP3FileSaver

#Region " Fields / Events "

    ''' <summary>
    ''' Lnge der Datei als Single
    ''' </summary>
    Private m_FileLength As Single

    ''' <summary>
    ''' Aktuell abgearbeitete Datei-Lnge 
    ''' </summary>
    Private m_FileDisplayLength As Single

    ''' <summary>
    ''' Aktuell abgearbeiteter Prozentanteil
    ''' </summary>
    Private m_AcDisplayLength As Integer = 0

#End Region

#Region " Constructor "

    ''' <summary>
    ''' Konstruktor
    ''' </summary>
    ''' <param name="File">MP3-Datei</param>
    ''' <param name="Path">Pfad, unter dem gespeichert werden soll</param>
    ''' <param name="ProgressForm">Referenz zur Fortschrittsanzeige-Form</param>
    Public Sub New(ByVal File As MP3File, ByVal Path As String, ByVal ProgressForm As frm_Progress)
        MyBase.New(File, Path, ProgressForm)
    End Sub

#End Region

#Region " Methods "

    ''' <summary>
    ''' Erhht die gespeicherten Werte zur Anzeige in der Progress-Form
    ''' </summary>
    ''' <param name="Value">Anzahl neu abgearbeiteter Bytes</param>
    Private Sub AddToDisplay(ByVal Value As Integer)
        m_FileDisplayLength += CSng(Value)
        SetAcDisplay(Math.Round(m_FileDisplayLength / m_FileLength * 100.0F))
    End Sub

    ''' <summary>
    ''' ndert die Anzeige in der Progress-Form
    ''' </summary>
    Private Sub SetAcDisplay(ByVal Value As Integer)
        If m_AcDisplayLength <> Value Then
            m_AcDisplayLength = Value
            Me.ProgressForm.RefreshProgress(m_AcDisplayLength)
            Me.ProgressForm.RefreshText(m_AcDisplayLength.ToString & "%")
        End If
    End Sub

    ''' <summary>
    ''' fhrt die Aktion zum Schreiben der MP3-Datei aus
    ''' </summary>
    Public Overrides Sub Execute()

        ' FileStream fr die neu zu erstellende Datei
        Dim FS As IO.FileStream = Nothing
        ' FileStream fr die Quell-Datei
        Dim SourceStream As IO.FileStream = Nothing
        ' Noch nicht abgearbeitete Anzahl Bytes
        Dim RestLength As Long

        ' Puffer zum Kopieren von Bytes aus dem Original-in den Ziel-Stream
        Dim Buffer(2047) As Byte
        ' Anzahl im gliger Bytes im Puffer 
        Dim BufferLength As Integer

        ' Maximum im Fortschritts-Formular auf 100 stellen
        Me.ProgressForm.RefreshMaxProgress(100)

        Try
            ' FileStream fr die neu zu erstellende Datei
            FS = New IO.FileStream(Path, IO.FileMode.OpenOrCreate, IO.FileAccess.Write, IO.FileShare.Read)
            ' FileStream fr die Quell-Datei
            SourceStream = New IO.FileStream(MP3Source.OutputPath & "\" & Me.File.FileName & ".mp3", IO.FileMode.Open)

            RestLength = SourceStream.Length
            m_FileLength = CSng(RestLength)
            While RestLength > 0

                ' Bei Click auf "Abbrechen"-Button Schleife verlassen
                If Me.ProgressForm.CancelButtonPushed Then
                    Exit While
                End If
                ' Anzahl der zu kopierenden Bytes ermitteln
                If RestLength >= 2048 Then
                    BufferLength = 2048
                    RestLength -= 2048
                    AddToDisplay(2048)
                Else
                    BufferLength = RestLength
                    RestLength = 0
                End If
                ' Bytes aus Quelldatei in Buffer schreiben
                SourceStream.Read(Buffer, 0, BufferLength)
                ' Bytes aus Buffer in neue MP3-Datei schreiben
                FS.Write(Buffer, 0, BufferLength)
            End While

        Catch ex As Exception

        Finally
            ' Egal, ob Fehler aufgetreten sind oder nicht, Streams freigeben
            If FS IsNot Nothing Then
                FS.Close()
                FS.Dispose()
            End If
            If SourceStream IsNot Nothing Then
                SourceStream.Close()
                SourceStream.Dispose()
            End If
        End Try
    End Sub

#End Region

End Class
