Imports System.ComponentModel
''' <summary>
''' Control zum Anzeigen und Bearbeiten von Datum und Zeit
''' </summary>
<DefaultEvent("Changed"), DefaultProperty("Time")> _
Public Class DateTimeControl

#Region " Fields / Events "
    ' angezeigte Zeit
    Private m_Time As Date
    ' Flag fr Initialisierung des Controls
    Private m_Init As Boolean = False

    ''' <summary>
    ''' Event bei nderung der eingestellten Zeit
    ''' </summary>
    Public Event Changed()
#End Region

#Region " Constructor "
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Time = Now
        m_Init = True
        Me.ClockControl1.Time = m_Time
        Me.DateTimePicker1.Value = m_Time
        m_Init = False
    End Sub

#End Region

#Region " Properties "
    ''' <summary>
    ''' Legt das angezeigte Datum fest oder dieses zurck
    ''' </summary>
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Property Time() As Date
        Get
            Return m_Time
        End Get
        Set(ByVal value As Date)
            If m_Time <> value Then
                m_Time = value
                m_Init = True
                Me.ClockControl1.Time = m_Time
                Me.DateTimePicker1.Value = m_Time
                m_Init = False
            End If
        End Set
    End Property
#End Region

#Region " Methods "
    ''' <summary>
    ''' Handler fr das ValueChanged-Event von DateTimePicker1
    ''' </summary>
    Private Sub DateTimePicker1_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DateTimePicker1.ValueChanged
        If m_Init Then Exit Sub
        If m_Time <> DateTimePicker1.Value Then
            m_Time = DateTimePicker1.Value
            Me.ClockControl1.Time = m_Time
            RaiseEvent Changed()
        End If
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event von ClockControl1
    ''' </summary>
    Private Sub ClockControl1_Changed() Handles ClockControl1.Changed
        If m_Time <> ClockControl1.Time Then
            m_Time = ClockControl1.Time
            m_Init = True
            Me.DateTimePicker1.Value = m_Time
            m_Init = False
            RaiseEvent Changed()
        End If
    End Sub
#End Region

End Class
