''' <summary>
''' UserControl zum Bearbeiten einer an mehreren Wochentagen mglichen Rekorder-Aufgabe
''' </summary>
''' <remarks></remarks>
Public Class CtlPeriodicRecorderTask

#Region " Fields / Events "

    ' Referenz zu periodischer Rekorder-Aufgabe
    Private WithEvents m_Task As RecordingTaskPeriodic
    ' Flag beim Initialisieren der angezeigten Werte
    Private m_Init As Boolean = False

#End Region

#Region " Constructor "

    ''' <summary>
    ''' Konstruktor mit Referenz zu periodischer Rekorder-Aufgabe
    ''' </summary>
    Public Sub New(ByVal Task As RecordingTaskPeriodic)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Task = Task
        m_Init = True
        ' Rekorder-Aufgabe im Control anzeigen
        Read_Task()
        m_Init = False
        Me.Label2.Text = My.LanguageInfo.TextEnd

        Dim DtFi As System.Globalization.DateTimeFormatInfo = My.Application.Culture.DateTimeFormat

        Me.CheckBoxMon.Text = DtFi.GetShortestDayName(DayOfWeek.Monday)
        Me.CheckBoxTue.Text = DtFi.GetShortestDayName(DayOfWeek.Tuesday)
        Me.CheckBoxWed.Text = DtFi.GetShortestDayName(DayOfWeek.Wednesday)
        Me.CheckBoxThu.Text = DtFi.GetShortestDayName(DayOfWeek.Thursday)
        Me.CheckBoxFri.Text = DtFi.GetShortestDayName(DayOfWeek.Friday)
        Me.CheckBoxSat.Text = DtFi.GetShortestDayName(DayOfWeek.Saturday)
        Me.CheckBoxSun.Text = DtFi.GetShortestDayName(DayOfWeek.Sunday)
    End Sub

#End Region

#Region " Methods "

    ''' <summary>
    ''' zeigt die referenzierte Rekorder-Aufgabe im Control an
    ''' </summary>
    Private Sub Read_Task()

        Me.ClockControl1.Time = m_Task.StartTime
        Me.ClockControl2.Time = m_Task.EndTime


        Me.CheckBoxMon.Checked = m_Task.Monday
        Me.CheckBoxTue.Checked = m_Task.Tuesday
        Me.CheckBoxWed.Checked = m_Task.Wednesday
        Me.CheckBoxThu.Checked = m_Task.Thursday
        Me.CheckBoxFri.Checked = m_Task.Friday
        Me.CheckBoxSat.Checked = m_Task.Saturday
        Me.CheckBoxSun.Checked = m_Task.Sunday



    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxMonday
    ''' </summary>
    Private Sub CheckBoxMon_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxMon.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Monday = CheckBoxMon.Checked
    End Sub
    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxTuesday
    ''' </summary>
    Private Sub CheckBoxTue_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxTue.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Tuesday = CheckBoxTue.Checked
    End Sub
    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxWednesday
    ''' </summary>
    Private Sub CheckBoxWed_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxWed.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Wednesday = CheckBoxWed.Checked
    End Sub
    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxThursday
    ''' </summary>
    Private Sub CheckBoxThu_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxThu.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Thursday = CheckBoxThu.Checked
    End Sub
    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxFriday
    ''' </summary>
    Private Sub CheckBoxFri_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxFri.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Friday = CheckBoxFri.Checked
    End Sub
    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxSaturday
    ''' </summary>
    Private Sub CheckBoxSat_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxSat.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Saturday = CheckBoxSat.Checked
    End Sub
    ''' <summary>
    ''' Handler fr das Changed-Event von CheckBoxSunday
    ''' </summary>
    Private Sub CheckBoxSun_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxSun.CheckedChanged
        If m_Init Then Exit Sub
        m_Task.Sunday = CheckBoxSun.Checked
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event von ClockControl1
    ''' </summary>
    Private Sub ClockControl1_Changed() Handles ClockControl1.Changed
        If m_Init Then Exit Sub
        m_Task.StartTime = ClockControl1.Time
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event von ClockControl2
    ''' </summary>
    Private Sub ClockControl2_Changed() Handles ClockControl2.Changed
        If m_Init Then Exit Sub
        m_Task.EndTime = ClockControl2.Time
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event der Rekorder-Aufgabe
    ''' </summary>
    Private Sub m_Task_Changed() Handles m_Task.Changed
        If Me.ClockControl1.Time <> m_Task.StartTime Then
            Me.ClockControl1.Time = m_Task.StartTime
        End If
        If Me.ClockControl2.Time <> m_Task.EndTime Then
            Me.ClockControl2.Time = m_Task.EndTime
        End If
    End Sub

#End Region

End Class
