''' <summary>
''' TreeNode, der ein RecordingTask-Objekt referenziert und dessen Inhalt anzeigt
''' </summary>
Public Class RecordingTaskTreeNode
    Inherits TreeNode
    ' referenziertes RecordingTask-Objekt
    Private WithEvents m_Task As RecordingTask

    ''' <summary>
    ''' Gibt das referenzierte RecordingTask-Objekt zurck
    ''' </summary>
    ReadOnly Property Task() As RecordingTask
        Get
            Return m_Task
        End Get
    End Property

    ''' <summary>
    ''' Konstruktor mit RecordingTask-Objekt-Referenz
    ''' </summary>
    Public Sub New(ByVal Task As RecordingTask)
        m_Task = Task
        ' Text und ImageIndex einstellen
        Me.Text = m_Task.ToString
        If m_Task.Type = RecordingTaskTypes.SingleTask Then
            Me.ImageIndex = 0
        Else
            Me.ImageIndex = 1
        End If
        Me.SelectedImageIndex = Me.ImageIndex
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event des referenzierten RecordingTask-Objekts
    ''' </summary>
    Private Sub m_Task_Changed() Handles m_Task.Changed
        ' Text des TreeNode aktualisieren
        Me.Text = m_Task.ToString
    End Sub
End Class

